codeforces C. Painting Fence

版权声明:本文为博主原创文章,未经博主允许不得转载。 https://blog.csdn.net/liyunlong41/article/details/51448986

C. Painting Fence
time limit per test
1 second
memory limit per test
512 megabytes
input
standard input
output
standard output

Bizon the Champion isn't just attentive, he also is very hardworking.

Bizon the Champion decided to paint his old fence his favorite color, orange. The fence is represented as n vertical planks, put in a row. Adjacent planks have no gap between them. The planks are numbered from the left to the right starting from one, the i-th plank has the width of 1 meter and the height of ai meters.

Bizon the Champion bought a brush in the shop, the brush's width is 1 meter. He can make vertical and horizontal strokes with the brush. During a stroke the brush's full surface must touch the fence at all the time (see the samples for the better understanding). What minimum number of strokes should Bizon the Champion do to fully paint the fence? Note that you are allowed to paint the same area of the fence multiple times.

Input

The first line contains integer n (1 ≤ n ≤ 5000) — the number of fence planks. The second line contains n space-separated integersa1, a2, ..., an (1 ≤ ai ≤ 109).

Output

Print a single integer — the minimum number of strokes needed to paint the whole fence.

Examples
input
5
2 2 1 2 1
output
3
input
2
2 2
output
2
input
1
5
output
1
Note

In the first sample you need to paint the fence in three strokes with the brush: the first stroke goes on height 1 horizontally along all the planks. The second stroke goes on height 2 horizontally and paints the first and second planks and the third stroke (it can be horizontal and vertical) finishes painting the fourth plank.

In the second sample you can paint the fence with two strokes, either two horizontal or two vertical strokes.

In the third sample there is only one plank that can be painted using a single vertical stroke.


题意: 有n个木板, 每个木板的高度为a[i], 要把这些木板全部都刷上喷漆, 可以横着刷, 也可以竖着刷, 每刷一次只能刷连续的部分, 可以重复刷, 求最小的步数.


分析:最多的次数就是竖着刷n次,  当然也可能先横着刷, 刷到最短的木板的高度, 然后剩下最短木板的两边, 再求这两边的最小步数, 这个是我们已经尝试解决的问题, 因此我们可以用递归分治来解决.每次解决的都是相同的问题, 但是规模在不断变小, 同时边界也存在.


#include<bits/stdc++.h>

#define inf 0x3f3f3f3f
using namespace std;

typedef long long ll;
typedef pair<int,int> pii;

const int N=100010,MOD=1e9+7;
int a[5678];

int dfs(int l,int r,int lastMinHeight)
{
    if(l>r) return 0;
    if(l==r) return a[l] > lastMinHeight;
    int m = min_element(a+l,a+r+1)-a;
    return min(r-l+1,dfs(l,m-1,a[m])+dfs(m+1,r,a[m])+a[m]-lastMinHeight);
}

int main()
{
    int n;
    cin>>n;
    for(int i=1;i<=n;i++) scanf("%d",a+i);
    printf("%d\n",dfs(1,n,0));
    return 0;
}



猜你喜欢

转载自blog.csdn.net/liyunlong41/article/details/51448986